Index: palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4495)
+++ palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4497)
@@ -358,85 +355,88 @@
 
 !
-!-  Fields for the interpolation of velocities on the rotor grid
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_int       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_int_1_l   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_int       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_int_1_l   !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_int       !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_int_1_l   !< 
-    
-!
-!-  rotor tendencies on the segments 
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: thrust_seg   !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: torque_seg_y !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: torque_seg_z !<    
-
-!
-!-  rotor tendencies on the rings
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  thrust_ring       !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  torque_ring_y     !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  torque_ring_z     !<
-    
-!
-!-  rotor tendencies on rotor grids for all turbines
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  thrust      !<
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  torque_y    !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  torque_z    !< 
-
-!
-!-  rotor tendencies on coordinate grid
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rot_tend_x  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rot_tend_y  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rot_tend_z  !< 
-!    
-!-  variables for the rotation of the rotor coordinates        
+!-  Fields for the interpolation of velocities on the rotor grid:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_int      !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_int_1_l  !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_int      !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_int_1_l  !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_int      !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_int_1_l  !<
+
+!
+!-  Rotor tendencies on the segments:
+    REAL(wp), DIMENSION(:), ALLOCATABLE :: thrust_seg    !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE :: torque_seg_y  !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE :: torque_seg_z  !<
+
+!
+!-  Rotor tendencies on the rings:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  thrust_ring    !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  torque_ring_y  !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  torque_ring_z  !<
+
+!
+!-  Rotor tendencies on rotor grids for all turbines:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  thrust     !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  torque_y   !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  torque_z   !<
+
+!
+!-  Rotor tendencies on coordinate grid:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rot_tend_x  !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rot_tend_y  !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rot_tend_z  !<
+
+!
+!-  Variables for the rotation of the rotor coordinates:
     REAL(wp), DIMENSION(1:n_turbines_max,1:3,1:3) ::  rot_coord_trans  !< matrix for rotation of rotor coordinates
-    
-    REAL(wp), DIMENSION(1:3) ::  rot_eigen_rad   !< 
-    REAL(wp), DIMENSION(1:3) ::  rot_eigen_azi   !< 
-    REAL(wp), DIMENSION(1:3) ::  rot_eigen_nor   !< 
-    REAL(wp), DIMENSION(1:3) ::  re              !< 
-    REAL(wp), DIMENSION(1:3) ::  rea             !< 
-    REAL(wp), DIMENSION(1:3) ::  ren             !< 
-    REAL(wp), DIMENSION(1:3) ::  rote            !< 
-    REAL(wp), DIMENSION(1:3) ::  rota            !< 
-    REAL(wp), DIMENSION(1:3) ::  rotn            !< 
-
-!
-!-- Fixed variables for the speed controller
-
-    LOGICAL  ::  start_up = .TRUE.   !< 
-    
-    REAL(wp) ::  Fcorner             !< corner freq for the controller low pass filter
-    REAL(wp) ::  region_25_min       !< min region 2.5
-    REAL(wp) ::  om_rate             !< rotor speed change
-    REAL(wp) ::  slope15             !< slope in region 1.5
-    REAL(wp) ::  region_25_slope     !< slope in region 2.5
-    REAL(wp) ::  trq_rate            !< torque change
-    REAL(wp) ::  vs_sysp             !< 
-    REAL(wp) ::  lp_coeff            !< coeff for the controller low pass filter 
-
-    REAL(wp), DIMENSION(n_turbines_max) :: rotor_speed_l = 0.0_wp !< local rot speed [rad/s]
-
-!
-!-- Fixed variables for the yaw controller
-
+
+    REAL(wp), DIMENSION(1:3) ::  rot_eigen_rad  !<
+    REAL(wp), DIMENSION(1:3) ::  rot_eigen_azi  !<
+    REAL(wp), DIMENSION(1:3) ::  rot_eigen_nor  !<
+    REAL(wp), DIMENSION(1:3) ::  re             !<
+    REAL(wp), DIMENSION(1:3) ::  rea            !<
+    REAL(wp), DIMENSION(1:3) ::  ren            !<
+    REAL(wp), DIMENSION(1:3) ::  rote           !<
+    REAL(wp), DIMENSION(1:3) ::  rota           !<
+    REAL(wp), DIMENSION(1:3) ::  rotn           !<
+
+!
+!-- Fixed variables for the speed controller:
+    LOGICAL  ::  start_up = .TRUE.  !<
+
+    REAL(wp) ::  fcorner           !< corner freq for the controller low pass filter
+    REAL(wp) ::  om_rate            !< rotor speed change
+    REAL(wp) ::  region_25_min      !< min region 2.5
+    REAL(wp) ::  region_25_slope    !< slope in region 2.5
+    REAL(wp) ::  slope15            !< slope in region 1.5
+    REAL(wp) ::  trq_rate           !< torque change
+    REAL(wp) ::  vs_sysp            !<
+    REAL(wp) ::  lp_coeff           !< coeff for the controller low pass filter
+
+    REAL(wp), DIMENSION(n_turbines_max) :: rotor_speed_l = 0.0_wp  !< local rot speed [rad/s]
+
+!
+!-- Fixed variables for the yaw controller:
+    INTEGER(iwp)                          ::  wdlon           !<
+    INTEGER(iwp)                          ::  wdsho            !<
+
+    LOGICAL,  DIMENSION(1:n_turbines_max) ::  doyaw = .FALSE.  !<
+
+    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  u_inflow         !< wind speed at hub
+    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  u_inflow_l       !<
+    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wdir             !< wind direction at hub
+    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wdir_l           !<
+    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wd2_l            !< local (cpu) short running avg of the wd
+    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wd30_l           !< local (cpu) long running avg of the wd
     REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  yawdir           !< direction to yaw
     REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  yaw_angle_l      !< local (cpu) yaw angle
-    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wd30_l           !< local (cpu) long running avg of the wd
-    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wd2_l            !< local (cpu) short running avg of the wd
-    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wdir             !< wind direction at hub
-    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  u_inflow         !< wind speed at hub
-    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  wdir_l           !< 
-    REAL(wp), DIMENSION(:)  , ALLOCATABLE ::  u_inflow_l       !<
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wd2              !<
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wd30             !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wd2              !<
-    LOGICAL,  DIMENSION(1:n_turbines_max) ::  doyaw = .FALSE.  !<
-    INTEGER(iwp)                          ::  WDLON            !<
-    INTEGER(iwp)                          ::  WDSHO            !<
-
-!
-!-- Variables that have to be saved in the binary file for restarts
-    REAL(wp), DIMENSION(1:n_turbines_max) ::  pitch_angle_old           = 0.0_wp  !< old constant pitch angle
+
+
+!
+!-- Variables that have to be saved in the binary file for restarts:
+    REAL(wp), DIMENSION(1:n_turbines_max) ::  pitch_angle_old         = 0.0_wp  !< old constant pitch angle
     REAL(wp), DIMENSION(1:n_turbines_max) ::  generator_speed         = 0.0_wp  !< curr. generator speed
     REAL(wp), DIMENSION(1:n_turbines_max) ::  generator_speed_f       = 0.0_wp  !< filtered generator speed
@@ -461,5 +461,5 @@
        MODULE PROCEDURE wtm_data_output
     END INTERFACE wtm_data_output
-    
+
     INTERFACE wtm_init_arrays
        MODULE PROCEDURE wtm_init_arrays
@@ -473,5 +473,5 @@
        MODULE PROCEDURE wtm_init_output
     END INTERFACE wtm_init_output
-    
+
     INTERFACE wtm_actions
        MODULE PROCEDURE wtm_actions
@@ -489,18 +489,18 @@
 
 
-    PUBLIC                                                                     &
-           dt_data_output_wtm,                                                 &
-           time_wtm,                                                           &
+    PUBLIC                                                                                         &
+           dt_data_output_wtm,                                                                     &
+           time_wtm,                                                                               &
            wind_turbine
 
-    PUBLIC                                                                     &
-           wtm_parin,                                                          &
-           wtm_check_parameters,                                               &
-           wtm_data_output,                                                    &
-           wtm_init_arrays,                                                    &
-           wtm_init_output,                                                    &
-           wtm_init,                                                           &
-           wtm_actions,                                                        &
-           wtm_rrd_global,                                                     &
+    PUBLIC                                                                                         &
+           wtm_parin,                                                                              &
+           wtm_check_parameters,                                                                   &
+           wtm_data_output,                                                                        &
+           wtm_init_arrays,                                                                        &
+           wtm_init_output,                                                                        &
+           wtm_init,                                                                               &
+           wtm_actions,                                                                            &
+           wtm_rrd_global,                                                                         &
            wtm_wrd_global
 
@@ -509,126 +509,126 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Parin for &wind_turbine_par for wind turbine model
-!------------------------------------------------------------------------------!
-    SUBROUTINE wtm_parin
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=80) ::  line  !< dummy string that contains the current line of the parameter file 
-
-       NAMELIST /wind_turbine_parameters/                                      &
-                   air_density, tower_diameter, dt_data_output_wtm,            &
-                   gear_efficiency, gear_ratio, generator_efficiency,          &
-                   generator_inertia, rotor_inertia, yaw_misalignment_max,     &
-                   generator_torque_max, generator_torque_rate_max, yaw_misalignment_min,                     &
-                   region_15_min, region_2_min, n_airfoils, n_turbines,        &
-                   rotor_speed, yaw_angle, pitch_angle, pitch_control,         &
-                   generator_speed_rated, generator_power_rated, hub_x, hub_y, hub_z,&
-                   nacelle_radius, rotor_radius, segment_length_tangential, segment_width_radial,  &
-                   region_2_slope, speed_control, tilt_angle, time_turbine_on, &
-                   tower_cd, pitch_rate,                                  &
-                   yaw_control, yaw_speed, tip_loss_correction
-!                   , nacelle_cd
-
-!
-!--    Try to find wind turbine model package
-       REWIND ( 11 )
-       line = ' '
-       DO WHILE ( INDEX( line, '&wind_turbine_parameters' ) == 0 )
-          READ ( 11, '(A)', END=12 )  line
-       ENDDO
-       BACKSPACE ( 11 )
-
-!
-!--    Read user-defined namelist
-       READ ( 11, wind_turbine_parameters, ERR = 10, END = 12 )
-!
-!--    Set flag that indicates that the wind turbine model is switched on
-       wind_turbine = .TRUE.
-
-       GOTO 12
-
- 10    BACKSPACE( 11 )
-       READ( 11 , '(A)') line
-       CALL parin_fail_message( 'wind_turbine_parameters', line )
-
- 12    CONTINUE   ! TBD Change from continue, mit ierrn machen
-
-    END SUBROUTINE wtm_parin
-
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE wtm_parin
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=80) ::  line  !< dummy string that contains the current line of the parameter file
+
+    NAMELIST /wind_turbine_parameters/                                                             &
+             air_density, tower_diameter, dt_data_output_wtm,                                      &
+                gear_efficiency, gear_ratio, generator_efficiency,                                 &
+                generator_inertia, rotor_inertia, yaw_misalignment_max,                            &
+                generator_torque_max, generator_torque_rate_max, yaw_misalignment_min,             &
+                region_15_min, region_2_min, n_airfoils, n_turbines,                               &
+                rotor_speed, yaw_angle, pitch_angle, pitch_control,                                &
+                generator_speed_rated, generator_power_rated, hub_x, hub_y, hub_z,                 &
+                nacelle_radius, rotor_radius, segment_length_tangential, segment_width_radial,     &
+                region_2_slope, speed_control, tilt_angle, time_turbine_on,                        &
+                tower_cd, pitch_rate,                                                              &
+                yaw_control, yaw_speed, tip_loss_correction
+!                , nacelle_cd
+
+!
+!-- Try to find wind turbine model package:
+    REWIND ( 11 )
+    line = ' '
+    DO WHILE ( INDEX ( line, '&wind_turbine_parameters' ) == 0 )
+       READ ( 11, '(A)', END = 12 )  line
+    ENDDO
+    BACKSPACE ( 11 )
+
+!
+!-- Read user-defined namelist:
+    READ ( 11, wind_turbine_parameters, ERR = 10, END = 12 )
+!
+!-- Set flag that indicates that the wind turbine model is switched on:
+    wind_turbine = .TRUE.
+
+    GOTO 12
+
+ 10 BACKSPACE ( 11 )
+    READ ( 11, '(A)' ) line
+    CALL parin_fail_message( 'wind_turbine_parameters', line )
+
+ 12 CONTINUE  ! TBD Change from continue, mit ierrn machen
+
+ END SUBROUTINE wtm_parin
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> This routine writes the respective restart data.
-!------------------------------------------------------------------------------!
-    SUBROUTINE wtm_wrd_global  
-
-
-       IMPLICIT NONE
-       
-
-       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
-
-          CALL wrd_write_string( 'generator_speed' )
-          WRITE ( 14 )  generator_speed
-
-          CALL wrd_write_string( 'generator_speed_f' )
-          WRITE ( 14 )  generator_speed_f
-
-          CALL wrd_write_string( 'generator_speed_f_old' )
-          WRITE ( 14 )  generator_speed_f_old
-
-          CALL wrd_write_string( 'generator_speed_old' )
-          WRITE ( 14 )  generator_speed_old
-
-          CALL wrd_write_string( 'rotor_speed' )
-          WRITE ( 14 )  rotor_speed
-
-          CALL wrd_write_string( 'yaw_angle' )
-          WRITE ( 14 )  yaw_angle
-
-          CALL wrd_write_string( 'pitch_angle' )
-          WRITE ( 14 )  pitch_angle
-
-          CALL wrd_write_string( 'pitch_angle_old' )
-          WRITE ( 14 )  pitch_angle_old
-
-          CALL wrd_write_string( 'torque_gen' )
-          WRITE ( 14 )  torque_gen
-
-          CALL wrd_write_string( 'torque_gen_old' )
-          WRITE ( 14 )  torque_gen_old
-
-       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
-
-          CALL wrd_mpi_io_global_array( 'generator_speed', generator_speed )
-          CALL wrd_mpi_io_global_array( 'generator_speed_f', generator_speed_f )
-          CALL wrd_mpi_io_global_array( 'generator_speed_f_old', generator_speed_f_old )
-          CALL wrd_mpi_io_global_array( 'generator_speed_old', generator_speed_old )
-          CALL wrd_mpi_io_global_array( 'rotor_speed', rotor_speed )
-          CALL wrd_mpi_io_global_array( 'yaw_angle', yaw_angle )
-          CALL wrd_mpi_io_global_array( 'pitch_angle', pitch_angle )
-          CALL wrd_mpi_io_global_array( 'pitch_angle_old', pitch_angle_old )
-          CALL wrd_mpi_io_global_array( 'torque_gen', torque_gen )
-          CALL wrd_mpi_io_global_array( 'torque_gen_old', torque_gen_old )
-
-       ENDIF
-       
-    END SUBROUTINE wtm_wrd_global    
-
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE wtm_wrd_global
+
+
+    IMPLICIT NONE
+
+
+   IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       CALL wrd_write_string( 'generator_speed' )
+       WRITE ( 14 )  generator_speed
+
+       CALL wrd_write_string( 'generator_speed_f' )
+       WRITE ( 14 )  generator_speed_f
+
+       CALL wrd_write_string( 'generator_speed_f_old' )
+       WRITE ( 14 )  generator_speed_f_old
+
+       CALL wrd_write_string( 'generator_speed_old' )
+       WRITE ( 14 )  generator_speed_old
+
+       CALL wrd_write_string( 'rotor_speed' )
+       WRITE ( 14 )  rotor_speed
+
+       CALL wrd_write_string( 'yaw_angle' )
+       WRITE ( 14 )  yaw_angle
+
+       CALL wrd_write_string( 'pitch_angle' )
+       WRITE ( 14 )  pitch_angle
+
+       CALL wrd_write_string( 'pitch_angle_old' )
+       WRITE ( 14 )  pitch_angle_old
+
+       CALL wrd_write_string( 'torque_gen' )
+       WRITE ( 14 )  torque_gen
+
+       CALL wrd_write_string( 'torque_gen_old' )
+       WRITE ( 14 )  torque_gen_old
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       CALL wrd_mpi_io_global_array( 'generator_speed', generator_speed )
+       CALL wrd_mpi_io_global_array( 'generator_speed_f', generator_speed_f )
+       CALL wrd_mpi_io_global_array( 'generator_speed_f_old', generator_speed_f_old )
+       CALL wrd_mpi_io_global_array( 'generator_speed_old', generator_speed_old )
+       CALL wrd_mpi_io_global_array( 'rotor_speed', rotor_speed )
+       CALL wrd_mpi_io_global_array( 'yaw_angle', yaw_angle )
+       CALL wrd_mpi_io_global_array( 'pitch_angle', pitch_angle )
+       CALL wrd_mpi_io_global_array( 'pitch_angle_old', pitch_angle_old )
+       CALL wrd_mpi_io_global_array( 'torque_gen', torque_gen )
+       CALL wrd_mpi_io_global_array( 'torque_gen_old', torque_gen_old )
+
+    ENDIF
+
+ END SUBROUTINE wtm_wrd_global
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Read module-specific global restart data (Fortran binary format).
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE wtm_rrd_global_ftn( found )
 
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                        &
         ONLY: length, restart_string
 
@@ -636,5 +636,5 @@
     IMPLICIT NONE
 
-    LOGICAL, INTENT(OUT)  ::  found 
+    LOGICAL, INTENT(OUT) ::  found
 
 
@@ -670,5 +670,5 @@
 
     END SELECT
-   
+
 
  END SUBROUTINE wtm_rrd_global_ftn
